Imports System.Text
Imports Syncfusion.DLS
Imports Syncfusion.DocIO
Imports Syncfusion.DocIO.DLS
Imports System.Collections
Imports System.IO
Imports System.ComponentModel
Imports System.Drawing
Imports System.Data
Imports System.Data.OleDb

Public Class WebForm1
    Inherits System.Web.UI.Page

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents Button1 As System.Web.UI.WebControls.Button
    Protected WithEvents CheckBox1 As System.Web.UI.WebControls.CheckBox

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private dataPath As String = Nothing
    Private connString As String = Nothing
    Private doc As WordDocument = Nothing

    Private conn As OleDbConnection = Nothing
    Private da As OleDbDataAdapter = Nothing
    Private cmd As OleDbCommand = Nothing
    Private ds As DataSet = Nothing

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Get Template document and database path.
        dataPath = Server.MapPath("Data")
        ' Database connection string.
        connString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & Path.Combine(dataPath, "Northwind.mdb")
        ' Get Data
        conn = New OleDbConnection(connString)
        conn.Open()
        cmd = New OleDbCommand("select OrderID from SyncOrders Order By OrderID", conn)
        da = New OleDbDataAdapter(cmd)
        ds = New DataSet
        da.SelectCommand = cmd
        ' Fill the SyncOrders datatable.
        da.Fill(ds, "SyncOrders")
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim masterDoc As WordDocument = New WordDocument
        Dim i As Integer = 0
        ' Generate Invoice for all orders in a single document.
        For Each row As DataRow In ds.Tables("SyncOrders").Rows
            If i = 5 Then
                Exit For
            End If
            i += 1
            ExecuteMail_Doc(CInt(row("OrderID")))
            AppendDocument(doc, masterDoc)
        Next row

        'Streaming the document to the client browser.
        If Me.CheckBox1.Checked Then
            masterDoc.Save("Sample.doc", FormatType.Doc, Response, HttpContentDisposition.InBrowser)
        Else
            masterDoc.Save("Sample.doc", FormatType.Doc, Response, HttpContentDisposition.Attachment)
        End If

    End Sub

    Private Sub ExecuteMail_Doc(ByVal ID As Integer)
        ' Create a new document
        doc = New WordDocument
        ' Load the template.
        doc.Open((System.IO.Path.Combine(dataPath, "SalesInvoiceDemo.doc")), FormatType.Doc)
        ' Execute Mail Merge with groups.
        doc.MailMerge.ExecuteGroup(GetTestOrder(ID))
        doc.MailMerge.ExecuteGroup(GetTestOrderTotals(ID))

        ' Using Merge events to do conditional formatting during runtime.
        AddHandler doc.MailMerge.MergeField, AddressOf MailMerge_MergeField

        Dim orderDetails As DataView = New DataView(GetTestOrderDetails(ID))
        orderDetails.Sort = "ExtendedPrice DESC"
        doc.MailMerge.ExecuteGroup(orderDetails)

    End Sub

    Private Function GetTestOrder(ByVal TestOrderId As Integer) As DataTable
        Dim table As DataTable = ExecuteDataTable(String.Format("SELECT * FROM SyncOrders WHERE OrderId = {0}", TestOrderId))
        table.TableName = "Orders"
        Return table
    End Function

    Private Function GetTestOrderDetails(ByVal TestOrderId As Integer) As DataTable
        Dim table As DataTable = ExecuteDataTable(String.Format("SELECT * FROM SyncOrderDetails WHERE OrderId = {0} ORDER BY ProductID", TestOrderId))
        table.TableName = "Order"
        Return table
    End Function

    Private Function GetTestOrderTotals(ByVal TestOrderId As Integer) As DataTable
        Dim table As DataTable = ExecuteDataTable(String.Format("SELECT * FROM SyncOrderTotals WHERE OrderId = {0}", TestOrderId))
        table.TableName = "OrderTotals"
        Return table
    End Function

    Private Function ExecuteDataTable(ByVal commandText As String) As DataTable
        ' Return DataTable
        Try
            conn = New OleDbConnection(connString)
            conn.Open()
            cmd = New OleDbCommand(commandText, conn)
            da = New OleDbDataAdapter(cmd)
            Dim table As DataTable = New DataTable
            da.Fill(table)
            Return table
        Finally
            If Not conn Is Nothing Then
                conn.Close()
            End If
        End Try
    End Function

    Private Sub MailMerge_MergeField(ByVal sender As Object, ByVal args As MergeFieldEventArgs)
        ' Conditionally format data during Merge.
        If args.RowIndex Mod 2 = 0 Then
            args.CharacterFormat.TextColor = Color.DarkBlue
        End If
    End Sub

    Private Sub AppendDocument(ByVal tempDoc As WordDocument, ByVal masterDoc As WordDocument)
        ' Enumerate all the sections from the first template document.
        Dim secs As IWSectionCollection = tempDoc.Sections
        For Each sec As IWSection In secs
            ' Cloning all the sections one by one and merging it to the new document.
            CType(masterDoc.Sections, WSectionCollection).Add(sec.Clone(masterDoc))
            ' Setting section break code to be the same as the template.
            doc.LastSection.BreakCode = sec.BreakCode
        Next sec
    End Sub

End Class
